
//
//
#include "../../podo/podo.h"
#include "../../custom/simple/ScrollPane.h"
#include "../../custom/simple/InputBox.h"






int podo::main() {

	using namespace podo;	
	
	podo::LanguageSystem::instance().changeToHangul();



	ComponentPtr topComponent(new podo::custom::simple ::ScrollPane());

	struct MyComponentListener : public ComponentListener {

		virtual bool const isComponentCloseOk(ComponentListenerHaver & sender, ComponentEventComponentCloseOk & event)  {
		
			

			using namespace podo::custom::simple;
			Component &component = static_cast<Component&>(sender);
			InputBox::Result  result = InputBox::showYesNo 
				(	 component, WString(L"fksjdfk"),WString(L"fdsf"));
		

			if( result  == InputBox::IB_YES   ){
				return true;
			}
			else {
				return false;

			}		
		}



	};

	topComponent->addComponentListener( new MyComponentListener());




	podo::FrameWindowPtr frameWindow = podo::FrameWindow::build (Point(0,0),Size(300,200), topComponent  );
	

	
	Application::instance().registFrameWindow(frameWindow);

	
	return Application::instance().run();
}














