#ifndef _Color_H_
#define _Color_H_
#include <string>
#include <sstream>

#include "UInt8.h"
#include "String.h"

namespace podo{
    class Color {
    private:
        UInt8 r;
        UInt8 g;
        UInt8 b;



    public:
    

        Color(UInt8 initRed = UInt8(), UInt8 initGreen = UInt8(), UInt8 initBlue = UInt8()) : r(initRed), g(initGreen), b(initBlue) {


        }

        ////
        // ڿ ڴ Ϸ  ִ  ״ .
        ////

        bool operator == (Color const & color_r) {


            return r == color_r.r && g == color_r.g && b == color_r.b;

        }

        bool operator != (Color const & color_r) {
            return operator == (color_r);

        }



    public:


        UInt8 getRed() const { return r; }
        void setRed(UInt8 initRed)  { r = initRed; }
        UInt8 getGreen() const { return g; }
        void setGreen (UInt8 initGreen) { g = initGreen; }
        UInt8 getBlue() const { return b; }
        void setBlue(UInt8 initBlue) { b = initBlue; }



    public:
     
	
	String toString() const {
		std::stringstream os;
		os << "( r: " << r;
		os << " g: " << g;
		os << " b: " << b;
		os << ")";

		String result = String(os.str());
		return result;
	}
    };
}
#endif
//Color_H



