#ifndef CPPUNITS_H
#define CPPUNITS_H


#include <vector>
#include "CppUnit.h"

namespace podo{
	
		class CppUnits {
			std::vector<testunit::CppUnit*> units;



		public:

			void add(testunit::CppUnit * unit_p){
				units.push_back(unit_p);

			}	

			
			void test(){
				for(size_t i = 0; i < units.size() ; ++i) {
					units[i]->test();
				}
			}

			~CppUnits() {

				for( size_t i = 0; i < units.size() ; ++i) {
					delete units[i];
				}

				units.clear();
			}

		};

	
}


#endif
//CPPUNIT_H


