#include "Filter.h"
#include "../global/Rect.h"





namespace podo{

		Line Filter::filtLine(Rect const & region, Point const from	,Point const to	){

			if(region.isNull()) {
				return Line::nullLine;
			}
		
			if (isVertical(from,to)) {
				return computeAtVertical(region,from,to);
			}else if (isHorizontal(from,to)) {
				return computeAtHorizontal(region,from,to);
			}else {			
				return computeAtUnKnown(region,from,to);
			}	

		}
}
