#ifndef PAINT_INOUTDRAWSTRUCT_DEFAULT_H_
#define PAINT_INOUTDRAWSTRUCT_DEFAULT_H_
#include "SystemApi.h"
#include "../global/Rect.p"
#include "../global/Point.p"

#include "../global/Pen.p"
#include "../global/Brush.p"
#include "../global/Font.p"

#include "InOutDrawStruct.h"

namespace podo{

		class InOutDrawStructDefault {


		public:

		


#if defined (_PODO_WIN32)
			typedef HDC DrawableHandle ;
#elif defined(_PODO_POSIX)
			struct DrawableHandle {
				Drawable drawable;
				GC gc;
			};
#endif




			
			static void fillRect	(DrawableHandle drawableHandle,Rect const & region, Point const &startPoint , Brush const &brush , Rect const & rt) ;
			static void lineLine	(DrawableHandle drawableHandle,Rect const & region, Point const &startPoint , Pen const &pen ,  Point const & from, Point const & to) ;
			

		

			/*static void write	(DrawableHandle drawableHandle,Rect const & region, 
				Point const &startPoint , Font const &font, WString const &text, 
				Rect const & rect,
				Font::VerticalWriteMode verticalMode ,
				Font::HorizontalWriteMode horizontalMode ) ;	*/	

			static void write	(DrawableHandle drawableHandle,Rect const & region, 
				Point const &startPoint , Font const &font, WString const &text, 
				Point const & point,
				Font::VerticalWriteMode verticalMode,
				Font::HorizontalWriteMode horizontalMode  ) ;		


			

		};
}


#endif 
//PAINT_INOUTDRAWSTRUCT_DEFAULT_H_

