#if defined(_PODO_WIN32)
#elif defined(_PODO_POSIX)


#include "GlobalHandle.h"
#include "../../global/Debug.h"

namespace podo{



	static GlobalHandle _globalHandle = NULL;



	GlobalHandle getGlobalHandle() {

		if(_globalHandle == NULL){
		//X 
			GlobalHandle initGlobalHandle = XOpenDisplay(NULL);
			if (initGlobalHandle == NULL) {
				fprintf(stderr, "%s: cannot connect to X server '%s'\n", "", "NULL");
				exit(1);
			}

			//setGlobalHandle(initGlobalHandle);
			_globalHandle = initGlobalHandle;
			XSynchronize(_globalHandle, True);


		}
		assertExp(_globalHandle != NULL);
		return _globalHandle;

	}

	//void setGlobalHandle( GlobalHandle globalHandle) {

	//	_globalHandle = globalHandle;
	//}

	void removeGlobalHandle() {
		if(_globalHandle != NULL) {

			//GlobalHandle globalHandle;
			//removeGlobalHandle();
			//X  .
			XCloseDisplay(_globalHandle);

			_globalHandle = NULL;

		}
	}

	




	}

#endif
