#ifndef COMPONENTREGIONUTIL_H
#define COMPONENTREGIONUTIL_H

#include "../global/Point.p"
#include "../global/Rect.p"
#include "../global/Size.p"

#include "Component.p"




namespace podo{

	class ComponentRegionUtil {
	public:		


		static Point const getPointOnClient(Component  const & component) ;
		static Rect const getRectOnClient(Component const & component) 		;	
		
	   

		static Point const getPointOnParent(Component  const & component) ;
		static Rect const getRectOnParent(Component  const & component) ;
		
		static Rect const  getClippingRectOnClient(Component const & component);

		static Size const getSize(Component const & component)  ;

		
	};
}
#endif
//COMPONENTREGIONUTIL_H



