#ifndef PODO_LIST_H_
#define PODO_LIST_H_

#include "data/ListData.h"

#include "Panel.h"
#include "FlowLayoutManager.h"

namespace podo {

	class List:public ListDataHaver, public ListView,public Panel< XVerticalFlowLayoutManager<1,25,2,2,2,2 > >{
		typedef List this_t;


		List() {			

		}


		virtual void listDataChanged(ListData const & listData) {

			this->accessContentsPane().clear();

			for(size_t index = 0; index < listData.size(); ++index) {
				this->accessContentsPane().addComponent(listData.at(index));
			}

			repaint();
		}

	};


}
#endif
//PODO_LIST_H_



