
#include "StateHMML.h"





#include "CharactorUtil.h"
#include "StateStack.h"
#include "../Receivable.h"


namespace podo{
	
		 

			void StateHMML::inputJaum(StateStack & stateStack,Receivable & receivable, JaumPtr jaum) {
				if(CharactorUtil::isCanJongsung(jaum) && CharactorUtil::isCanComposite(_jon1,jaum)) {

					stateStack.pushStateHMMLL(_cho,_jun1,_jun2,_jon1,jaum);
					receivable.setString(stateStack.accessTop().computeWChar(),true);
				}
				else {
					stateStack.changeToStart();
					stateStack.pushStateH(jaum);
					receivable.addString(stateStack.accessTop().computeWChar(),true);
                    
				}
			}
			void StateHMML::inputMoum(StateStack & stateStack,Receivable & receivable, MoumPtr moum){
				stateStack.changeToStart();
				stateStack.pushStateH(_jon1);
				stateStack.pushStateHM(_jon1,moum);
				receivable.addString(stateStack.accessTop().computeWChar(),true);
			}
			wchar_t const StateHMML::computeWChar(){
				return CharactorUtil::compositeAll(
					CharactorUtil::changeToChosungCode(_cho),
					CharactorUtil::changeToJungsungCode (_jun1,_jun2));

			}

		
}

