

#include "StateM.h"

#include "CharactorUtil.h"
#include "StateStack.h"
#include "../Receivable.h"

#include "Moum.h"

namespace podo{
	
		 
			void StateM::inputJaum(StateStack & stateStack,Receivable & receivable, JaumPtr jaum) {
				
				stateStack.changeToStart();
				stateStack.pushStateH (jaum);
				receivable.addString(stateStack.accessTop().computeWChar(),true);
			

			}
			void StateM::inputMoum(StateStack & stateStack,Receivable & receivable, MoumPtr moum){
				if(CharactorUtil::isCanComposite(_jun,moum) ) {
                    stateStack.pushStateMM (_jun,moum);
					receivable.setString(stateStack.accessTop().computeWChar(),true);
				}
				else {
					stateStack.changeToStart();
					stateStack.pushStateM (moum);
					receivable.addString(stateStack.accessTop().computeWChar(),true);
				}

			}
			wchar_t const StateM::computeWChar(){
				return _jun->ch;
			}
		
}

