
#include "StateStack.h"

#include "StateStart.h"
#include "StateH.h"
#include "StateHM.h"
#include "StateHML.h"
#include "StateHMLL.h"
#include "StateHMM.h"
#include "StateHMML.h"
#include "StateHMMLL.h"
#include "StateHMMLL.h"
#include "StateM.h"
#include "StateMM.h"
#include "StateLL.h"



namespace podo{
	
		
			void StateStack::changeToStart() {
				_datas.clear();	


				static StateStart state;
				_datas.push_back(&state);
				
			}

			void StateStack::pushStateHMMLL(JaumPtr cho1, MoumPtr jun1, MoumPtr jun2, JaumPtr jon1 , JaumPtr jon2){
			
				static StateHMMLL state;
				state.setChoJunJunJonJon(cho1,jun1,jun2,jon1,jon2);

				_datas.push_back(&state);
			
			}

			void StateStack::pushStateHMML(JaumPtr cho1, MoumPtr jun1, MoumPtr jun2, JaumPtr jon1 ){
				static StateHMML state;
				state.setChoJunJunJon(cho1,jun1,jun2,jon1);
				_datas.push_back(&state);
			
			
			}

			void  StateStack::pushStateHM(JaumPtr cho1, MoumPtr jun1){
				static StateHM state;
				state.setjaumMoum(cho1,jun1);
				_datas.push_back(&state);
			
			}

			void  StateStack::pushStateHMLL(JaumPtr cho1, MoumPtr jun1,  JaumPtr jon1 , JaumPtr jon2){
				static StateHMLL state;
				state.setChoJunJonJon(cho1,jun1,jon1,jon2);
				_datas.push_back(&state);
			
			}

			void StateStack::pushStateHMM(JaumPtr cho1, MoumPtr jun1, MoumPtr jun2){
				static StateHMM state;
				state.setChoJunJun(cho1,jun1,jun2);
				_datas.push_back(&state);
			
			}

			void StateStack::pushStateHML(JaumPtr cho1, MoumPtr jun1, JaumPtr jon1 ){
				static StateHML state;
				state.setChoJunJon(cho1,jun1,jon1);
				_datas.push_back(&state);
			
			}

			void StateStack::pushStateM( MoumPtr jun1){
				static StateM state;
				state.setJun(jun1);
				_datas.push_back(&state);
							
			}

			void StateStack::pushStateLL( JaumPtr jon1 , JaumPtr jon2){
				static StateLL state;
				state.setJonJon(jon1,jon2);
				_datas.push_back(&state);
			
			}

			void StateStack::pushStateH(JaumPtr cho1){
				static StateH state;
				state.setJaum(cho1);
				_datas.push_back(&state);
						
			}

			void StateStack::pushStateMM(  MoumPtr jun1, MoumPtr jun2){
				static StateMM state;
				state.setJunJun(jun1,jun2);
				_datas.push_back(&state);
			
			
			}

			

			State & StateStack::accessTop() {
				return * _datas.back();

			}




		
}


