#ifndef PODO_LANGUAGE_HANGUL_STATESTACK_H
#define PODO_LANGUAGE_HANGUL_STATESTACK_H

#include "State.p"
#include "Jaum.p"
#include "Moum.p"

#include <vector>
namespace podo{
	
		 
			class StateStack{
				
			private:
				std::vector<State*> _datas;
				
			public:
				void pushStateHMMLL(JaumPtr cho1, MoumPtr jun1, MoumPtr jun2, JaumPtr jon1 , JaumPtr jon2);
				void pushStateHMML(JaumPtr cho1, MoumPtr jun1, MoumPtr jun2, JaumPtr jon1 );
				void pushStateHM(JaumPtr cho1, MoumPtr jun1);
				void pushStateHMLL(JaumPtr cho1, MoumPtr jun1,  JaumPtr jon1 , JaumPtr jon2);
				void pushStateHMM(JaumPtr cho1, MoumPtr jun1, MoumPtr jun2);
				void pushStateHML(JaumPtr cho1, MoumPtr jun1, JaumPtr jon1 );
				void pushStateM( MoumPtr jun1);
				void pushStateLL( JaumPtr jon1 , JaumPtr jon2);
				void pushStateH(JaumPtr cho1);
				void pushStateMM(  MoumPtr jun1, MoumPtr jun2);
	
                State & accessTop() ;

				void pop() {
					_datas.pop_back();
				}

				
				StateStack(){

				}

				void changeToStart() ;


				size_t const size() const {
					return _datas.size();

				}

				bool const isStart(){
					return _datas.size() == 1;

				}

			};
		
}

#endif 
//PODO_LANGUAGE_HANGUL_STATESTACK_H


