#ifndef _BITMAP_H
#define _BITMAP_H


#include "../../system/SystemApi.h"
#include "../../global/Size.h"
#include "Graphics.p"
#include "../../system/BitmapImpl.h"

#include "InOutGraphics.p"


namespace podo{

		class Bitmap {


		private:
		
			BitmapImpl _bitmapImpl;

			Size const getSize() const {
				return _bitmapImpl.getSize();
			}

                      
			InOutGraphicsPtr createGraphics();
		public:

			Bitmap(uint32_t width = 1000, uint32_t height = 1000);
			Bitmap(Size const & size);

			~Bitmap();
			



		};

}



#endif

///
