
//
//
//
#include "MouseBeforeDrag.h"
#include "../system/DragData.p"

#include "../TopWindow.h"


#include "../Component.h"
#include "../CreatedComponents.h"

//
#include "MouseStateFactory.h"
#include "MouseInDrag.h"
#include "MouseOutDrag.h"


namespace podo{
	

	

		void  MouseBeforeDrag::distributeAtMouseButtonDown(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute, Point const & pointOnClient, MouseButton  const &button,bool const & bIn) {
			assertExp(bIn);
			assertExp(button != this->_buttonDragStarted );
		}
        void  MouseBeforeDrag::distributeAtMouseButtonUp(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute, Point const & pointOnClient, MouseButton  const &button,bool const & bIn) {
			assertExp(bIn);


			if(bExcute 	&& (topComponent.get() != NULL )) {
				if( (button == _buttonDragStarted) ){

					if(	CreatedComponents::instance().hasComponent (*this->_componentDragStarted ) ) {

						MouseEventButtonClicked eve(pointOnClient,this->_pointOnClientDragStarted ,this->_buttonDragStarted );						
						_componentDragStarted->invokeMouseListener(eve);			
					}else {
						// Ʈ  ޼   ȴ..

					}


				}else {
					// ٸ   ϰ   ޶ 
					//׹     ϱ Ʊ  ó Ѵ..

				}

			}




			if(button == _buttonDragStarted) {						
				topWindow.ChangeMouseState(MouseStateFactory::createIn(pointOnClient));		
			}else {
               //none;
			}
		}
        void  MouseBeforeDrag::distributeAtMouseMove(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute, Point const & pointOnClient,bool const & bIn) {
			
			
			
		

			DragDataPtr dragData;
			
			
			if(bExcute && topComponent.get() != NULL && 
				CreatedComponents::instance().hasComponent (*this->_componentDragStarted )) {	

				Component & comp = topComponent->findComponent(this->_pointOnClientDragStarted );
				GetDragDataEvent eve(this->_buttonDragStarted);
				
				_componentDragStarted->invokeGetDragDataListener(eve);


				dragData = eve.getDragData();

			}



			
			if(bIn) {
				MouseStatePtr indrag_p= MouseStateFactory::createInDrag (
					this->_buttonDragStarted ,
					this->_pointOnClientDragStarted ,dragData ,pointOnClient,*this->_componentDragStarted );
				topWindow.ChangeMouseState(indrag_p);
						
			}else {
				topWindow.ChangeMouseState(MouseStateFactory::createOutDrag(this->_buttonDragStarted ,
					this->_pointOnClientDragStarted ,dragData ,pointOnClient,*this->_componentDragStarted ));
			}


			
			

			


		}
        void  MouseBeforeDrag::distributeAtMouseEntered(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute) {
			topWindow.ChangeMouseStateIllegal(MouseStateFactory::createBeforeDrag(this->_buttonDragStarted,this->_pointOnClientDragStarted,*this->_componentDragStarted));
		}

        void  MouseBeforeDrag::distributeAtMouseExited(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute) {
			topWindow.ChangeMouseStateIllegal(MouseStateFactory::createOut());
			

		}

		

}
