#ifndef PODO_PROCESS_MOUSEOUT_H_
#define PODO_PROCESS_MOUSEOUT_H_
#include "MouseState.h"


#include "MouseStateFactory.p"

namespace podo{
     
        
		class MouseOut:public MouseState{


			
		private:
			friend class MouseStateFactory;	
			MouseOut(){}


			virtual void  distributeAtMouseButtonDown(TopWindow &topWindow, ComponentPtr topComponent, bool const & bExcute,
				Point const & pointOnClient, MouseButton  const &button,bool const & bIn) ;
            virtual void  distributeAtMouseButtonUp(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute,
				Point const & pointOnClient, MouseButton  const &button,bool const & bIn) ;
            virtual void  distributeAtMouseMove(TopWindow &topWindow, ComponentPtr topComponent, bool const & bExcute,
				Point const & pointOnClient,bool const & bIn) ;
            virtual void  distributeAtMouseEntered(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute);
            virtual void  distributeAtMouseExited(TopWindow &topWindow, ComponentPtr topComponent,bool const & bExcute) ;	

		
			virtual String toString () {
				return String("MouseOut");
			}
        
		};
    
}

#endif 
//PODO_PROCESS_MOUSEOUT_H_

