#ifndef _POPO_CUSTOM_SIMPLE_DEFAULTSCROLLDRAW_H_
#define _POPO_CUSTOM_SIMPLE_DEFAULTSCROLLDRAW_H_

#include "../../podo/podo.h"

namespace podo { namespace custom {namespace simple {

	struct DefaultScrollDraw{

		static void paint( Scroll const & scroll,InOutGraphics & graphics_r){


					Color scrollPageColor(UInt8(50),UInt8(50),UInt8(50));
					Color scrollBodyColor(UInt8(250),UInt8(50),UInt8(50));
					Color scrollArrowColor(UInt8(50),UInt8(250),UInt8(50));
		                

					graphics_r.setBrush(Brush(scrollPageColor));

					graphics_r.fillRect(scroll.getPageRect());

					graphics_r.setBrush(Brush(scrollArrowColor));
	                
					graphics_r.fillRect(scroll.getLowerArrowRect());
					graphics_r.fillRect(scroll.getHigherArrowRect());

					graphics_r.setBrush(Brush(scrollBodyColor));

					graphics_r.fillRect(scroll.getLowerBodyRect());
					graphics_r.fillRect(scroll.getHigherBodyRect());


				}


	};





}}}
#endif 
//POPO_CUSTOM_SIMPLE_DEFAULTSCROLLDRAW_H_


