

#include "Debug.h"
#include <string>


				
static int bugCount = 0;

	void Debug::traceAssert(const char * errorString, const char * file, unsigned int line) {

	bugCount ++;
	trace(bugCount<<"°(assertExp)   : "<<	 errorString << "\n" <<  
		"filename:"<< file << ":" << line << "\n");
}
void Debug::traceAssertEquals(const char * typeName , const char * expect,const char * current, unsigned int line){
	bugCount ++;
	trace("At :"<<typeName<<"\t line : "<<line<<"\n"<<
		"expected: "<< expect<<"\n"<<
		"but: "<<current<<'\n');

}
void Debug::traceAssertDiffs(const char * typeName ,const char * expect,const char * current, unsigned int line){
	bugCount ++;

	trace("At :"<<typeName<<"\t line : "<<line<<"\n"<<
		"Notexpected: "<< expect <<"\n"<<
		"but: "<<current <<'\n');
		
}	





#if defined(_PODO_POSIX)
///#incude <iostream>

namespace podo{
	


		void Debug::traceFunc(const char *str) {
		//	std::cerr<<str;
			fprintf(stderr,str);
			
			
	
		}
}

#elif defined(_PODO_WIN32)
		#include <afx.h>	


	
	
		void Debug::traceFunc(char const * pszFormat)	{


			const int MAX_LEN = 1024;

			if(strlen(pszFormat) > MAX_LEN) {
				

				size_t const end = (strlen(pszFormat) / MAX_LEN) ;
				for(size_t i= 0; i < end ; ++i ) {
					std::string temp(&pszFormat[MAX_LEN * i] ,&pszFormat[MAX_LEN * (i + 1)]);
					TRACE(temp.c_str());
				}
				
				TRACE(&pszFormat[MAX_LEN * (end )]);

			}else {

				TRACE(pszFormat);
			}
		
		}

#endif
