#ifndef PODO_PODO_DEBUG_H_
#define PODO_PODO_DEBUG_H_

#include <sstream>
//#include <typeinfo.h>

#include "Bug.h"


	
	class Debug { 
	public:
	
	
		static void traceFunc(const char *str) ;
		static void traceAssert(const char * errorString, const char * fileName, unsigned int line) ;
		static void traceAssertEquals(const char * expect,const char * current, const char * fileName, unsigned int line);
		static void traceAssertDiffs(const char * expect,const char * current, const char * fileName, unsigned int line);

	};
	

            
#if defined (_PODO_DEBUG)
	
	#define trace(arg1)		{	std::ostringstream sout;	sout<<arg1; sout.flush();Debug::traceFunc(sout.str().c_str()  );}
	#define assertExp(exp)		(void)((exp) || (	Debug::traceAssert(   (char *) #exp ,  __FILE__ ,__LINE__ ), 0 ) )
	#define assertEquals(  current,expect)  (void) ( ( (expect)  == (current) ) || 	(Debug::traceAssertEquals((typeid(*this)).name(),#expect ,#current,__LINE__),0) )
	#define assertDiffs(  current,expect)  	(void) ( ( (expect)  != (current) ) ||  (Debug::traceAssertDiffs((typeid(*this)).name(),#expect ,#current ,__LINE__),0) )
	#define reportBug(arg) 	Bug::sendToFile(e)

 
#elif defined(_PODORELEASE)
	 

	#define trace(arg1)		((void) 0)
	#define assertExp(exp)		((void) 0)
	#define assertEquals(  current,expect)  ((void) 0)
	#define assertDiffs(  current,expect)  	((void) 0)
	#define reportBug(arg) 	((void) 0)

				
//((void) 0)
		
#endif
	

//
//#define assertExp(exp) (void)( (exp) || (_myassert(#exp, __FILE__, __LINE__), 0) )



#endif 
//// PODO_PODO_DEBUG_H_
