#ifndef SYSTEM_TYPE_MOUSE_BUTTON_H_
#define SYSTEM_TYPE_MOUSE_BUTTON_H_

#include "MouseButton.p"
#include "String.h"



namespace podo{
    
		class MouseButton{

	
			

		private:
			String  _str;			
			MouseButton(String const &str) :_str(str){

			}

		public:


			MouseButton & operator = (MouseButton const & mouseButton) {
				_str = mouseButton._str ;
			}

			MouseButton  (MouseButton const & mouseButton) {
				_str = mouseButton._str ;
			}

			

		
			static const MouseButton LEFT;
			static const MouseButton RIGHT; 
			static const MouseButton MIDDLE; 
			static const MouseButton NONE;

			const bool operator==(MouseButton const & button)const {
				return _str == button._str ;
			}

			const bool operator!=(MouseButton const & button) const{
				return _str != button._str ;
			}
	
			String const toString() const ;

		};
	
}

#endif
//SYSTEM_TYPE_MOUSE_BUTTON_H_

