

#ifndef PODO_SYSTEMTYPE_BASIC_H_
#define PODO_SYSTEMTYPE_BASIC_H_




	

#if defined(_PODO_WIN32)

#define _WIN32_WINNT 0x0400

#include <windows.h>	
#elif defined(_PODO_POSIX)
#include <X11/Xlib.h>
#endif	



#ifdef min
#undef min
#endif

#ifdef max
#undef max
#endif



namespace podo {

#if defined(_PODO_WIN32)
		typedef HWND   WindowID;
#elif defined(_PODO_POSIX)
		typedef Window WindowID;
#endif 


#if defined(_PODO_WIN32)
		typedef UINT   MessageType;
#elif defined(_PODO_POSIX)
		typedef int MessageType;
#endif 


}










#endif
//PODO_SYSTEMTYPE_BASIC_H_

