#ifndef COMPONENTCHAINUTIL_H
#define COMPONENTCHAINUTIL_H

#include "Component.p"


namespace podo{
	class ComponentChainUtil {
	public:	

		

		static unsigned int const getLevel(Component  const & comp) ;

		static bool const isClientComponent(Component  const & comp){
            return getLevel(comp) == 0;
		}

		static Component const & getRoot(Component const & comp,unsigned int const &rootNum) ;

		static Component const & getCommonParent(Component const & comp1,Component const & comp2) ;

		static Component const & getClientComponent(Component const  & comp) ;


		
		static Component  & accessRoot(Component  & comp,unsigned int const &rootNum) ;

		static Component & accessCommonParent(Component  & comp1,Component  & comp2) ;

		static Component  & accessClientComponent(Component  & comp);
		
		
		static bool const isChainOk(Component const& comp);




		

		
	};

}
#endif
//COMPONENTCHAINUTIL_H


//
//Component const & ComponentChainUtil::computeCommonParent(Component const & comp1,Component const & comp2) {
///* 2 Ʈ ־  θ ã ִ ƾ̴.
//				-ּ θ Background ȴ.
//					ϸ NullComponent ϱ  ̷ ߻ ƾ Ѵ.
//			*/
//
////̰ üũϴ  Visible¶  Component Background  Ǿ
//		//true Ǳ , ̰ ׽Ʈ Ѵٸ  Լ  ʴ´..
//		assertExp(comp1.isVisible());
//assertExp(comp2.isVisible());
//
//		
//
//int smallerLevel = std::min(comp1.getLevel(), comp2.getLevel());
//
//int i = smallerLevel;
//while ((& comp1.getRoot(i) != & comp2.getRoot(i))) {
//
//
//if (i <= 0) {
//assertExp(false);
//return *Component::createNull();
//}
//
//--i;
//}
//
//int commonLevel = i;
//
//assertExp((& comp1.getRoot(commonLevel) == & comp2.getRoot(commonLevel)));
//
//return comp1.getRoot(commonLevel);
//
//}
//void ComponentChainUtil::isChainOk(){}
//Component const & ComponentChainUtil::getRoot(unsigned int rootNum) const {
//
//      
//
//    if (rootNum == getLevel()) {
//        return * this;
//
//    } else if (rootNum < getLevel()) {
//        return getParent().getRoot(rootNum);
//
//    }
//    else {
//        //if (rootNum > getLevel())
//            assertExp(false);
//        return * this;
//    }
//
//}
//unsigned int ComponentChainUtil::getLevel() const {
//
//
//    if (!hasParent() ) {
//assertExp(false);
//        return 0;
//    }
//
//if(&Background::instance () == this){
//
//return 0;
//
//}
//else {
//return 1 + getParent().getLevel();
//}
//
//
//}
//bool ComponentChainUtil::isVisible() const {
//if(parent_p == NULL) {
//return false;
//}
//
//if(this == &Background::instance()) {
//return true;
//}
//
//    return getParent().isVisible();
//}
//
