


#include "StateHM.h"

#include "StateHMM.h"
#include "StateH.h"
#include "StateM.h"


#include "CharactorUtil.h"
#include "StateStack.h"
#include "../Receivable.h"

namespace podo{
	
		
			void StateHM::inputJaum(StateStack & stateStack,Receivable & receivable, JaumPtr jaum) {
				if(CharactorUtil::isCanJongsung(jaum)) {
                    stateStack.pushStateHML (_jaum,_moum,jaum);
					wchar_t temp = stateStack.accessTop().computeWChar();
					receivable.setString(temp,true);
				}
				else {
					stateStack.changeToStart();
					stateStack.pushStateH (jaum);
					receivable.addString(stateStack.accessTop().computeWChar(),true);
				}
			}
			void StateHM::inputMoum(StateStack & stateStack,Receivable & receivable, MoumPtr moum){
				if(CharactorUtil::isCanComposite(_moum,moum) ) {
                    stateStack.pushStateHMM (_jaum,_moum,moum);
					receivable.setString(stateStack.accessTop().computeWChar(),true);
				}
				else {
					stateStack.changeToStart();
					stateStack.pushStateM (moum);
					receivable.addString(stateStack.accessTop().computeWChar(),true);
				}
			}
			wchar_t const StateHM::computeWChar(){
				return 	CharactorUtil::compositeAll(
					CharactorUtil::changeToChosungCode (_jaum),
					CharactorUtil::changeToJungsungCode (_moum));

			}


			
		
}

