
#include "StateHML.h"



#include "CharactorUtil.h"
#include "StateStack.h"
#include "../Receivable.h"


namespace podo{
	
		

			void StateHML::inputJaum(StateStack & stateStack,Receivable & receivable, JaumPtr jaum) {
				if(CharactorUtil::isCanJongsung(jaum) &&	CharactorUtil::isCanComposite(_jon,jaum)  ) {
					stateStack.pushStateHMLL(_cho,_jun,_jon,jaum);
					receivable.setString(stateStack.accessTop().computeWChar(),true);
				}else {

					stateStack.changeToStart();
					stateStack.pushStateH(jaum);
					receivable.addString(stateStack.accessTop().computeWChar(),true);
				}

			}
			void StateHML::inputMoum(StateStack & stateStack,Receivable & receivable, MoumPtr moum){
				
					stateStack.pop();
					receivable.setString(stateStack.accessTop().computeWChar(),true);

					stateStack.changeToStart();
					stateStack.pushStateH(_jon);
					stateStack.pushStateHM(_jon,moum);
					receivable.addString(stateStack.accessTop().computeWChar(),true);
				
			}
			wchar_t const StateHML::computeWChar(){
				return 	CharactorUtil::compositeAll(
					CharactorUtil::changeToChosungCode (_cho),
					CharactorUtil::changeToJungsungCode (_jun),
					CharactorUtil::changeToJongsungCode(_jon)
					
					);

			}


		
}

