
#include "StateHMM.h"





#include "CharactorUtil.h"
#include "StateStack.h"
#include "../Receivable.h"

namespace podo{
	
		

			void StateHMM::inputJaum(StateStack & stateStack,Receivable & receivable, JaumPtr jaum) {

				if(CharactorUtil::isCanJongsung(jaum)) {
					stateStack.pushStateHMML (_cho,_jun1, _jun2,jaum);
					receivable.setString(stateStack.accessTop().computeWChar(),true);
				}
				else {
					stateStack.changeToStart();
					stateStack.pushStateH(jaum);
					receivable.setString(stateStack.accessTop().computeWChar(),true);


				}
			}

			void StateHMM::inputMoum(StateStack & stateStack,Receivable & receivable, MoumPtr moum){
				stateStack.changeToStart();
				stateStack.pushStateM(moum);
				receivable.addString(stateStack.accessTop().computeWChar(),true);
			}

			wchar_t const StateHMM::computeWChar(){

				return CharactorUtil::compositeAll(
					CharactorUtil::changeToChosungCode(_cho),
					CharactorUtil::changeToJungsungCode (_jun1,_jun2));


			}


		
}

