
#include "StateHMMLL.h"



#include "CharactorUtil.h"
#include "StateStack.h"
#include "../Receivable.h"


namespace podo{
	
		 
			void StateHMMLL::inputJaum(StateStack & stateStack,Receivable & receivable, JaumPtr jaum) {
				
				stateStack.changeToStart();
				stateStack.pushStateH(jaum);
				receivable.addString(stateStack.accessTop().computeWChar(),true);
                
			}
			void StateHMMLL::inputMoum(StateStack & stateStack,Receivable & receivable, MoumPtr moum){
				stateStack.changeToStart();
				stateStack.pushStateH(_jon2);
				stateStack.pushStateHM(_jon2,moum);
				receivable.addString(stateStack.accessTop().computeWChar(),true);
			}
			wchar_t const StateHMMLL::computeWChar(){
				return CharactorUtil::compositeAll(
					CharactorUtil::changeToChosungCode(_cho),
					CharactorUtil::changeToJungsungCode (_jun1,_jun2),
					CharactorUtil::changeToJongsungCode (_jon1,_jon2));
			}



		
}

