
#include "StateMM.h"

#include "CharactorUtil.h"
#include "StateStack.h"
#include "../Receivable.h"

namespace podo{
	
		 
			void StateMM::inputJaum(StateStack & stateStack,Receivable & receivable, JaumPtr jaum) {
				
				stateStack.changeToStart();
				stateStack.pushStateH (jaum);
				receivable.addString(stateStack.accessTop().computeWChar(),true);
			

			}
			void StateMM::inputMoum(StateStack & stateStack,Receivable & receivable, MoumPtr moum){
				
				stateStack.changeToStart();
				stateStack.pushStateM (moum);
				receivable.addString(stateStack.accessTop().computeWChar(),true);
			}
				
			wchar_t const StateMM::computeWChar(){
				return CharactorUtil::composite(_jun1,_jun2);

			}
			
		
}

